#! /bin/sh
# @(#)listmidas.sh	1.1 (ESO-IPG) 07/12/91 14:16:03
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           listmidas.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       
#                 Usage: 
#
# .REMARKS        The external variable $MIDASHOME and $MIDVERS must be set 
#
# .AUTHOR         Carlos Guirao
# .VERSION 2.2    14-Oct-1988:		Cosmetic changes
# .VERSION 2.3    05-Dec-1989:		Adding "echo" definition

echo=echo
if [ "`echo -n`" = "-n" ] ; then
    SV_NONL="\c"
else
    echo="echo -n"
fi

#
# START
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
   echo "Error: Variable \$MIDASHOME or \$MIDVERS not defined."
   exit 1
fi
MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix

clear
while : ; do
(echo ""
echo "	LIST OF AVAILABLE PACKAGES FOR MIDAS:"
echo ""
echo "	NAME		CATEGORY"
echo "	========================"
for categ in applic stdred contrib
do
    if [ ! -d $MIDASHOME/$MIDVERS/$categ ]; then
	continue
    fi
    cd $MIDASHOME/$MIDVERS/$categ
    for pack in `ls | egrep -v 'lib|exec|proc'`
    do
        if [ -f $pack/src/makefile -o \
	     -f $pack/lib/makefile -o \
	     -f $pack/proc/makefile ] ; then
            $echo  "	$pack      	$categ	"  $SV_NONL
            if [ ! -f $pack/DESCRIPTION ] ; then
		echo "(DESCRIPTION file not available)"
	    else
		echo ""
	    fi
	fi
   done
done
echo "" ) | more
cd $MID_INSTALL
echo "Type <Q> to quit or <L> to list again."

while : ; do
    $echo "Select NAME: " $SV_NONL
    read name
    name=`echo $name | tr A-Z a-z`
    if [ "$name" = "q" ] ; then
	clear
	exit
    fi
    if [ "$name" = "l" ] ; then
	break
    fi
    if [ "$name" = "" ] ; then
	continue
    fi
    if [ -d $MIDASHOME/$MIDVERS/applic/$name ] ; then
	categ=applic
    elif [ -d $MIDASHOME/$MIDVERS/stdred/$name ] ; then
	categ=stdred
    elif [ -d $MIDASHOME/$MIDVERS/contrib/$name ] ; then
	categ=contrib
    else
	echo "$name: No such package with that name"
	continue
    fi

    if [ -f $MIDASHOME/$MIDVERS/$categ/$name/DESCRIPTION ] ; then
	cat $MIDASHOME/$MIDVERS/$categ/$name/DESCRIPTION | more
	echo ""
	continue
    else
	echo "DESCRIPTION file for package <$name> not available."
    fi
done
done
clear
exit
